<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="page_ble_quick_start" kind="group">
    <compoundname>page_ble_quick_start</compoundname>
    <title>Quick Start Guide</title>
    <detaileddescription>
<para>The PSoC 6 BLE Middleware can be used in various software environments such as ModusToolbox, etc.</para><para>Refer to <ref kindref="compound" refid="page_ble_toolchain">Supported Software and Tools</ref> page. The quickest way to get started is using the Code Examples. Cypress Semiconductor continuously extends its portfolio of code examples at the <ulink url="http://www.cypress.com/">Cypress Semiconductor website</ulink> and at the <ulink url="https://github.com/cypresssemiconductor.com">Cypress Semiconductor GitHub</ulink> site.</para><para>You must accomplish several tasks to implement a BLE standard profile application:<itemizedlist>
<listitem><para><ref kindref="member" refid="page_ble_quick_start_1group_ble_quick_start1">PSoC 6 BLE Middleware configuration in BT Configurator</ref></para></listitem><listitem><para><ref kindref="member" refid="page_ble_quick_start_1group_ble_quick_start2">System and PSoC 6 BLE Middleware Initialization</ref></para></listitem><listitem><para><ref kindref="member" refid="page_ble_quick_start_1group_ble_quick_start3">Main Loop Implementation</ref></para></listitem><listitem><para><ref kindref="member" refid="page_ble_quick_start_1group_ble_quick_start4">Stack Event Handler</ref></para></listitem><listitem><para><ref kindref="member" refid="page_ble_quick_start_1group_ble_quick_start5">Service-specific Event Handler</ref></para></listitem><listitem><para><ref kindref="member" refid="page_ble_quick_start_1group_ble_quick_start6">Implement Low-power Performance</ref></para></listitem></itemizedlist>
</para><para>The snippets below show an implementation of a simple Bluetooth SIG-defined standard profile called Find <ulink url="https://www.bluetooth.org/docman/handlers/downloaddoc.ashx?doc_id=239389">Me Profile (FMP)</ulink>. BLE midlleware is configured to operate in Complete BLE Protocol Single CPU mode. In this mode,the BLE functionality is entirely on the CM4 CPU core. It uses a software interface for communication between the controller and host. Refer to <ref kindref="compound" refid="page_ble_section_configuration_considerations">Configuration Considerations</ref> for details on how to configure the BLE middleware for operation in Complete BLE Protocol Dual CPU or Controller-only (HCI over Software API) modes.</para>
<para><heading level="1">PSoC 6 BLE Middleware configuration in BT Configurator</heading></para>
<para>     </para><para>The <ulink url="https://www.cypress.com/ModusToolboxBLEConfig">ModusToolbox BT Configurator Guide</ulink> describes how to use BT Configurator. The BT Configurator Tool can be launched in ModusToolbox IDE from the BLE personality, as well as in stand-alone mode. Refer to <ulink url="https://www.cypress.com/products/modustoolbox-software-environment">ModusToolbox Software Environment, Quick Start Guide, Documentation, and Videos</ulink>.</para><para>For this Quick Start Guide, the PSoC 6 BLE Middleware is configured as the Find Me Target in the GAP Peripheral role with the settings shown in the figures below:</para><para><bold>General Settings</bold><linebreak />
 Use the General tab for general configuration of the Bluetooth resource (e.g GAP role, max number of BLE connection, etc). <image name="bt_config_general_tab.jpg" type="html" />
</para><para><bold>GATT Settings</bold><linebreak />
 Use the GATT Settings tab to configure Profile-specific parameters. For this Quick Start Guide we add only Find Me profile (Find Me Target (GATT Server)). <image name="bt_config_gatt_tab.jpg" type="html" />
</para><para><bold>GAP Settings</bold><linebreak />
 Use the GAP Settings tab to configure GAP parameters, which define the general connection settings required when connecting Bluetooth devices. It contains various parameters based on the item you select in the tree.</para><para><emphasis>General</emphasis><linebreak />
 In this panel you configure general GAP parameters (e.g. Public device address, Device Name, Appearance, Adv/Scan/Connections TX power level, etc). <image name="bt_config_gap_tab.jpg" type="html" />
</para><para><emphasis>Advertisement Settings</emphasis><linebreak />
 In this panel you configure the general parameters for advertisement configuration (e.g. Discovery mode, Advertising type, Filter policy, Advertising Interval, etc). <image name="bt_config_advervicement_setting.jpg" type="html" />
</para><para><emphasis>Advertisement Packet</emphasis><linebreak />
 In this panel you configure the Advertisement data to be used in device advertisements. <image name="bt_config_advervicement_packet.jpg" type="html" />
</para><para><emphasis>Security Settings</emphasis><linebreak />
 In this panel you configure security settings for the device. The example uses a configuration that does not require authentication, encryption, or authorization for data exchange. <image name="bt_config_securiti_configuration.jpg" type="html" />
</para><para>PSoC 6 BLE Middleware configuration is saved in files "cycfg_ble.h" and "cycfg_ble.c". These files must be attached to the user project.</para>

<para><heading level="1">System and PSoC 6 BLE Middleware Initialization</heading></para>
<para>When PSoC 6 BLE MCU is reset, the application should perform system initialization which includes: setting up the CPU cores for execution, enabling global interrupts, and enabling other components used in the design ( UART, MCWDT, etc). After the CPUs are initialized the application initializes the PSoC 6 BLE Middleware, which sets up a complete BLE subsystem.</para><para>As part of the PSoC 6 BLE Middleware initialization, you must:<itemizedlist>
<listitem><para>Initialize the BLESS interrupt. See <ref kindref="member" refid="page_ble_section_configuration_considerations_1group_ble_section_conf_cons_intr">Configure BLESS Interrupt</ref> for detailed information. The code below shows how to implement the routine (ISR) handler of the BLESS interrupt service (refer to BlessInterrupt() function). The <ref kindref="member" refid="group__group__ble__common__api__functions_1gaf973ee7f4097d25ee569fd8bd3172265">Cy_BLE_BlessIsrHandler()</ref> function is called from BlessInterrupt() to process interrupt events generated by BLESS.</para></listitem><listitem><para>Register the generic event handler function to be called by the BLE stack to notify of pending events. Refer to <ref kindref="member" refid="group__group__ble__common__api__functions_1ga3d3e2bf00cc87f8dfc17fa0c68fd7506">Cy_BLE_RegisterEventCallback()</ref> function.</para></listitem><listitem><para>Call <ref kindref="member" refid="group__group__ble__common__api__functions_1gac43daf6ecb84fde5390065532c7b7e69">Cy_BLE_Init()</ref> to initialize PSoC 6 BLE Middleware. Pass the address of the configuration structure generated by the BT Configurator, cy_ble_config (exposed in cycfg_ble.c).</para></listitem><listitem><para>Call <ref kindref="member" refid="group__group__ble__common__api__functions_1ga71930f6a2639719f896326a9bb73f543">Cy_BLE_Enable()</ref> to enable the BLE subsystem.</para></listitem><listitem><para>Register service-specific event handlers (the example uses only the IAS event handler to handle Immediate Alert Service related events). Refer to <ref kindref="member" refid="group__group__ble__service__api___i_a_s__server__client_1ga5eaefdb8aace72fb807a01ae2dcffc50">Cy_BLE_IAS_RegisterAttrCallback()</ref> function.</para></listitem></itemizedlist>
</para><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_syslib.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_sysint.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cycfg.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cycfg_ble.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Global<sp />variables</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />Alert<sp />Level<sp />value<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint8_t<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />alertLevel<sp />=<sp /><ref kindref="member" refid="group__group__ble__common__api__macros_1ga3f7727fbf709001469a187eb1df36d34">CY_BLE_NO_ALERT</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />variables<sp />to<sp />initialize<sp />the<sp />BLE<sp />stack<sp />timer<sp />to<sp />get<sp />a<sp />1-second<sp />interval<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ble__timer__info__t">cy_stc_ble_timer_info_t</ref><sp /><sp />timerParam<sp />=<sp />{<sp />.<ref kindref="member" refid="structcy__stc__ble__timer__info__t_1a7ad3d2bb388c7fb54c0bf6fdb50a2273">timeout</ref><sp />=<sp />1u<sp /></highlight><highlight class="comment">/*<sp />second<sp />*/</highlight><highlight class="normal"><sp />};</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint8_t<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />mainTimer<sp />=<sp />1u;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />LED8<sp />and<sp />LED9<sp />port<sp />definitions<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />LED8_PORT<sp />GPIO_PRT1</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />LED8_PIN<sp />5U</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />LED9_PORT<sp />GPIO_PRT13</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />LED9_PIN<sp />7U</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />BLESS<sp />interrupt<sp />configuration.</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />It<sp />is<sp />used<sp />when<sp />BLE<sp />middleware<sp />operates<sp />in<sp />BLE<sp />Single<sp />CM4<sp />Core<sp />mode.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_stc_sysint_t<sp />blessIsrCfg<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />BLESS<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrSrc<sp /><sp /><sp /><sp /><sp /><sp />=<sp />bless_interrupt_IRQn,</highlight></codeline>
<codeline><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />interrupt<sp />priority<sp />number<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />1u</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Private<sp />Function<sp />Prototypes</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />AppMainLoop(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />AppCallBack(uint32_t<sp />event,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*eventParam);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />IasEventHandler(uint32_t<sp />event,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*eventParam);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />LowPowerImplementation(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Function<sp />Name:<sp />BlessInterrupt</highlight></codeline>
<codeline><highlight class="comment">********************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />BLESS<sp />ISR</highlight></codeline>
<codeline><highlight class="comment">*<sp />It<sp />is<sp />used<sp />used<sp />when<sp />BLE<sp />middleware<sp />operates<sp />in<sp />BLE<sp />single<sp />CM4</highlight></codeline>
<codeline><highlight class="comment">*</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />BLESS<sp />ISR<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />BlessInterrupt(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Call<sp />interrupt<sp />processing<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__functions_1gaf973ee7f4097d25ee569fd8bd3172265">Cy_BLE_BlessIsrHandler</ref>();</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Function<sp />Name:<sp />main()</highlight></codeline>
<codeline><highlight class="comment">********************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Summary:</highlight></codeline>
<codeline><highlight class="comment">*<sp /><sp />Main<sp />function<sp />for<sp />the<sp />BLE<sp />project.</highlight></codeline>
<codeline><highlight class="comment">*</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />main(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />interrupts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />__enable_irq();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />all<sp />peripherals<sp />and<sp />system<sp />resources<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />init_cycfg_all();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />GPIO<sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_GPIO_Pin_FastInit(LED9_PORT,<sp />LED9_PIN,<sp />CY_GPIO_DM_STRONG_IN_OFF,<sp />1u,<sp />HSIOM_SEL_GPIO);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_GPIO_Pin_FastInit(LED8_PORT,<sp />LED8_PIN,<sp />CY_GPIO_DM_STRONG_IN_OFF,<sp />1u,<sp />HSIOM_SEL_GPIO);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />BLESS<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cy_ble_config.hw-&gt;blessIsrConfig<sp />=<sp />&amp;blessIsrCfg;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysInt_Init(cy_ble_config.hw-&gt;blessIsrConfig,<sp />BlessInterrupt);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />the<sp />generic<sp />event<sp />handler<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__functions_1ga3d3e2bf00cc87f8dfc17fa0c68fd7506">Cy_BLE_RegisterEventCallback</ref>(AppCallBack);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />BLE<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__functions_1gac43daf6ecb84fde5390065532c7b7e69">Cy_BLE_Init</ref>(&amp;cy_ble_config);</highlight></codeline>
<codeline><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />BLE<sp />Low-power<sp />Mode<sp />(LPM)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__functions_1ga11dd55190fcf99efcc2dd0f625014f4b">Cy_BLE_EnableLowPowerMode</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />BLE<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__functions_1ga71930f6a2639719f896326a9bb73f543">Cy_BLE_Enable</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />the<sp />IAS<sp />CallBack<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__service__api___i_a_s__server__client_1ga5eaefdb8aace72fb807a01ae2dcffc50">Cy_BLE_IAS_RegisterAttrCallback</ref>(IasEventHandler);</highlight></codeline>
<codeline><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Main<sp />loop<sp />implementation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(1)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Main<sp />loop<sp />implementation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />AppMainLoop();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}<sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><heading level="1">Main Loop Implementation</heading></para>
<para>The main loop in the example has a simply flow:<itemizedlist>
<listitem><para>process the BLE stack pending events by a call to <ref kindref="member" refid="group__group__ble__common__api__functions_1ga0f1982f915c28b0d5a317442bec9eafc">Cy_BLE_ProcessEvents()</ref></para></listitem><listitem><para>process a received alert level: updates the LEDs based on the alert level</para></listitem><listitem><para>restarts the BLE stack timer to get a 1-second interval to blink the LED</para></listitem><listitem><para>the application goes into Low-power mode by call to the LowPowerImplementation() function.</para></listitem></itemizedlist>
</para><para><programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />AppMainLoop(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Cy_BLE_ProcessEvents()<sp />allows<sp />the<sp />BLE<sp />stack<sp />to<sp />process<sp />pending<sp />events<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__functions_1ga0f1982f915c28b0d5a317442bec9eafc">Cy_BLE_ProcessEvents</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(alertLevel)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__macros_1ga3f7727fbf709001469a187eb1df36d34">CY_BLE_NO_ALERT</ref><sp />:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED9_PORT,<sp />LED9_PIN,<sp />1u);<sp /></highlight><highlight class="comment">/*<sp />LED_OFF<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />break<sp />;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__macros_1gada3c7899e683c326e4ab13a09ca288fd">CY_BLE_MILD_ALERT</ref><sp />:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(mainTimer)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Toggle<sp />the<sp />alert<sp />LED<sp />after<sp />a<sp />timeout<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Inv(LED9_PORT,<sp />LED9_PIN);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />break<sp />;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__macros_1ga58ceaf19cdb7e80cdd9b1b75ba512faa">CY_BLE_HIGH_ALERT</ref><sp />:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED9_PORT,<sp />LED9_PIN,<sp />0u);<sp /></highlight><highlight class="comment">/*<sp />LED_ON<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />break<sp />;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Restart<sp />the<sp />BLE<sp />stack<sp />timer.<sp />Used<sp />to<sp />get<sp />a<sp />1-second<sp />interval<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />blink<sp />the<sp />LED<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(mainTimer)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />mainTimer<sp />=<sp />0u;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__functions_1gaf696cb866225d442f66baa0bcae397ef">Cy_BLE_StartTimer</ref>(&amp;timerParam);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enter<sp />deep-sleep<sp />to<sp />achieve<sp />low<sp />power<sp />in<sp />the<sp />device<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />LowPowerImplementation();</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><heading level="1">Stack Event Handler</heading></para>
<para>The BLE stack within the PSoC 6 BLE Middleware generates events. These events provide status and data to the application firmware through the BLE stack event handler.</para><para>The event handler must handle a few basic events from the stack. For the Find Me Target application in this code example, the BLE stack event-handler must process the events described in table below. The actual code recognizes and responds to additional events.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;BLE Stack Event Name &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Event Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Event Handler Action  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_EVT_STACK_ON &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;BLE stack initialization is completed successfully &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Start advertisement and reflect the advertisement state on the LED &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_EVT_GAP_DEVICE_DISCONNECTED &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;BLE link with the peer device is disconnected &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Restart advertisement and reflect the advertisement state on the LED &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_EVT_GAP_DEVICE_CONNECTED &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;BLE link with the peer device is established &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Update the BLE link state on the LED &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_EVT_GAPP_ADVERTISEMENT_START_STOP &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;BLE stack advertisement start/stop event &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Shutdown the BLE stack &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_EVT_STACK_SHUTDOWN_COMPLETE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;BLE stack has been shutdown &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Put the device into Hibernate mode &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_BLE_EVT_GAP_AUTH_REQ &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;BLE authentication request received &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Call &lt;a href="group__group__ble__common__api__gap__peripheral__functions.html#group__group__ble__common__api__gap__peripheral__functions_1gafd058b11ddcf322f0389c51917465334"&gt;Cy_BLE_GAPP_AuthReqReply()&lt;/a&gt; to reply to the authentication request from Central &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;The code snippets show examples of how the event handler responds to an identified events. See the actual source code for a complete understanding.</verbatim></para><para><programlisting><codeline><highlight class="normal">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="normal">*<sp />Function<sp />Name:<sp />AppCallBack</highlight></codeline>
<codeline><highlight class="normal">********************************************************************************</highlight></codeline>
<codeline><highlight class="normal">*<sp />Summary:<sp />This<sp />is<sp />an<sp />event<sp />callback<sp />function<sp />to<sp />receive<sp />events<sp />from<sp />the<sp />PSoC<sp />6<sp />BLE<sp />Middleware.</highlight></codeline>
<codeline><highlight class="normal">*</highlight></codeline>
<codeline><highlight class="normal">*<sp />Parameters:</highlight></codeline>
<codeline><highlight class="normal">*<sp /><sp /><sp />event<sp /><sp /><sp /><sp /><sp /><sp />-<sp />The<sp />event<sp />code.</highlight></codeline>
<codeline><highlight class="normal">*<sp /><sp /><sp />eventParam<sp />-<sp />The<sp />event<sp />parameters.</highlight></codeline>
<codeline><highlight class="normal">*</highlight></codeline>
<codeline><highlight class="normal">*******************************************************************************/</highlight></codeline>
<codeline><highlight class="normal">void<sp />AppCallBack(uint32_t<sp />event,<sp />void<sp />*eventParam)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />switch(event)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp />/*<sp />Generic<sp />events<sp />(e.g<sp />CY_BLE_EVT_STACK_ON,<sp />CY_BLE_EVT_STACK_BUSY_STATUS,<sp />etc)<sp />*/</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp />.<sp />.<sp />.</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp />/*<sp />GAP<sp />Events<sp />(e.g<sp />CY_BLE_EVT_GAP_AUTH_REQ,<sp />CY_BLE_EVT_GAP_AUTH_COMPLETE,<sp />CY_BLE_EVT_GAP_DEVICE_CONNECTED,<sp />etc)<sp />*/</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<sp />.<sp />.</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp />/*<sp />GATT<sp />Events<sp />(e.g<sp />CY_BLE_EVT_GATT_CONNECT_IND,<sp />CY_BLE_EVT_GATT_DISCONNECT_IND,<sp />etc)<sp />*/</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<sp />.<sp />.</highlight></codeline>
<codeline />
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp />/*<sp />Other<sp />Events<sp />*/</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<sp />.<sp />.</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para><para>In this snippet, the handler starts advertising in response to the CY_BLE_EVT_STACK_ON event. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />event<sp />is<sp />received<sp />when<sp />the<sp />BLE<sp />stack<sp />is<sp />initialized<sp />and<sp />turned<sp />ON</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />by<sp />invoking<sp />the<sp />Cy_BLE_StackInit()<sp />function<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86a8934f1150b681fd0edbc395a27a9613d">CY_BLE_EVT_STACK_ON</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enter<sp />into<sp />discoverable<sp />mode<sp />so<sp />that<sp />remote<sp />can<sp />find<sp />it<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__gap__peripheral__functions_1gac26286c502401fc1bb3c9561b66733d7">Cy_BLE_GAPP_StartAdvertisement</ref>(CY_BLE_ADVERTISING_FAST,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_BLE_PERIPHERAL_CONFIGURATION_0_INDEX);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
</programlisting> In this snippet, the handler responds to the "advertisement start/stop" event. The code toggles the LEDs appropriately. If advertising has started, the advertisement LED turns on. The disconnect LED turns off, because the device started advertising and is ready for connection. If advertising stops, the code sets the LEDs appropriately, and sets a flag to enter Hibernate mode. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />event<sp />indicates<sp />the<sp />peripheral<sp />device<sp />has<sp />started/stopped<sp />advertising<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86af7df7271c667f3dc2a99e492499134c6">CY_BLE_EVT_GAPP_ADVERTISEMENT_START_STOP</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__ble__common__api__functions_1ga4b070074c2af74238130830cfb570188">Cy_BLE_GetAdvertisementState</ref>()<sp />==<sp /><ref kindref="member" refid="group__group__ble__common__api__gap__definitions_1gga1af3aeb3bb744f0d9b7fe0b6859b8edcace0f9cadd252b1959497c6340b95385a">CY_BLE_ADV_STATE_STOPPED</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{<sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />fast<sp />and<sp />slow<sp />advertising<sp />period<sp />is<sp />complete,<sp />go<sp />to<sp />Low-power<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />mode<sp />(Hibernate)<sp />and<sp />wait<sp />for<sp />an<sp />external<sp />user<sp />event<sp />to<sp />wake<sp />up<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />the<sp />device<sp />again<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__functions_1gadb3de6a7f54f20646dcea989aad7e0f2">Cy_BLE_Disable</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED8_PORT,<sp />LED8_PIN,<sp />1u);<sp /></highlight><highlight class="comment">/*<sp />LED_OFF<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED9_PORT,<sp />LED9_PIN,<sp />1u);<sp /></highlight><highlight class="comment">/*<sp />LED_OFF<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;<sp /><sp /></highlight></codeline>
</programlisting> In this snippet, the handler responds to the "disconnected" event. It starts advertising and sets the LEDs correctly. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />event<sp />is<sp />generated<sp />when<sp />disconnected<sp />from<sp />a<sp />remote<sp />device<sp />or<sp />failed<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />to<sp />establish<sp />connection<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86af76865d155be4ef9a842e5fe30eec6d5">CY_BLE_EVT_GAP_DEVICE_DISCONNECTED</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />BLE<sp />advertising<sp />for<sp />30<sp />seconds<sp />and<sp />update<sp />the<sp />link<sp />status<sp />on<sp />the<sp />LEDs<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__gap__peripheral__functions_1gac26286c502401fc1bb3c9561b66733d7">Cy_BLE_GAPP_StartAdvertisement</ref>(CY_BLE_ADVERTISING_FAST,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_BLE_PERIPHERAL_CONFIGURATION_0_INDEX);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />default<sp />value<sp />for<sp />alert<sp />level<sp />(CY_BLE_NO_ALERT)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />alertLevel<sp />=<sp /><ref kindref="member" refid="group__group__ble__common__api__macros_1ga3f7727fbf709001469a187eb1df36d34">CY_BLE_NO_ALERT</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED8_PORT,<sp />LED8_PIN,<sp />0u);<sp /></highlight><highlight class="comment">/*<sp />LED_ON<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED9_PORT,<sp />LED9_PIN,<sp />1u);<sp /></highlight><highlight class="comment">/*<sp />LED_OFF<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
</programlisting> In this snippet, the handler receives a timeout from BLE stack timer. In this example the BLE stack timer is used to get a 1-second interval to blink the LED. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />event<sp />is<sp />received<sp />when<sp />there<sp />is<sp />a<sp />timeout<sp />and<sp />the<sp />application</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />must<sp />handle<sp />the<sp />event<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86a5faab937dcd719a5cc5cb8e8b749dcaa">CY_BLE_EVT_TIMEOUT</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<sp />(((<ref kindref="compound" refid="structcy__stc__ble__timeout__param__t">cy_stc_ble_timeout_param_t</ref><sp />*)eventParam)-&gt;reasonCode<sp />==<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__definitions_1gga9401245e7b20db19f6b735d6295a6113a337fd92ce11151df7eaab75a89fe9694">CY_BLE_GENERIC_APP_TO</ref>)<sp />&amp;&amp;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((<ref kindref="compound" refid="structcy__stc__ble__timeout__param__t">cy_stc_ble_timeout_param_t</ref><sp />*)eventParam)-&gt;timerHandle<sp />==<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />timerParam.<ref kindref="member" refid="structcy__stc__ble__timer__info__t_1a0f48deb9ffee581143a5c57c2beb3722">timerHandle</ref>)<sp />)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Indicate<sp />that<sp />the<sp />timer<sp />is<sp />raised<sp />to<sp />the<sp />main<sp />loop<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />mainTimer++;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Update<sp />the<sp />LED<sp />state<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__ble__common__api__functions_1ga4b070074c2af74238130830cfb570188">Cy_BLE_GetAdvertisementState</ref>()<sp />==<sp /><ref kindref="member" refid="group__group__ble__common__api__gap__definitions_1gga1af3aeb3bb744f0d9b7fe0b6859b8edcaa52f2e981fb0e7902fe2dea2df3e0510">CY_BLE_ADV_STATE_ADVERTISING</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Advertising<sp />state<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Inv(LED8_PORT,<sp />LED8_PIN);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED9_PORT,<sp />LED9_PIN,<sp />1u);<sp /></highlight><highlight class="comment">/*<sp />LED_OFF<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__ble__common__api__functions_1ga20cdd5796acf84dcea347f3c40274352">Cy_BLE_GetNumOfActiveConn</ref>()<sp />==<sp />0u)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Disconnected<sp />state<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED8_PORT,<sp />LED8_PIN,<sp />0u);<sp /></highlight><highlight class="comment">/*<sp />LED_ON<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED9_PORT,<sp />LED9_PIN,<sp />1u);<sp /></highlight><highlight class="comment">/*<sp />LED_OFF<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Connected<sp />state:<sp />update<sp />the<sp />alert<sp />level<sp />value<sp />LED8<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_GPIO_Write(LED8_PORT,<sp />LED8_PIN,<sp />1u);<sp /></highlight><highlight class="comment">/*<sp />LED_OFF<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}<sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
</programlisting> In this snippet, the handler puts the device into Hibernate mode in response to the CY_BLE_EVT_STACK_SHUTDOWN_COMPLETE event. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />event<sp />is<sp />used<sp />to<sp />inform<sp />the<sp />application<sp />that<sp />BLE<sp />Stack<sp />shutdown</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />is<sp />complete<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86a19cedb90d0f015c6656b1228cdd67931">CY_BLE_EVT_STACK_SHUTDOWN_COMPLETE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />device<sp />into<sp />Hibernate<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SysPm_SystemEnterHibernate();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
</programlisting> In this snippet, the handler responds to the authentication request from the Central device. The peripheral device must call <ref kindref="member" refid="group__group__ble__common__api__gap__peripheral__functions_1gafd058b11ddcf322f0389c51917465334">Cy_BLE_GAPP_AuthReqReply()</ref> to reply to the authentication request from the Central. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />event<sp />can<sp />be<sp />received<sp />by<sp />a<sp />device<sp />in<sp />Peripheral<sp />or<sp />Central<sp />role.<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />When<sp />it<sp />is<sp />received<sp />by<sp />a<sp />device<sp />in<sp />a<sp />Peripheral<sp />role,<sp />it<sp />must<sp />call<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Cy_BLE_GAPP_AuthReqReply()<sp />to<sp />reply<sp />to<sp />the<sp />authentication<sp />request<sp />from<sp />Central<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ble__common__api__events_1gga7c1ef7e6d246e0f3eb6c883e23d82b86a308f9ebe8fdaa68ee1cbec7af7f5b731">CY_BLE_EVT_GAP_AUTH_REQ</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(cy_ble_config.authInfo[CY_BLE_SECURITY_CONFIGURATION_0_INDEX].security<sp />==</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_BLE_GAP_SEC_MODE_1<sp />|<sp /><ref kindref="member" refid="group__group__ble__common__api__gap__definitions_1ggafb9216cdc0f9e4c7b84ef3ac7b3dbc94aa13a718ebe8472f4e9625d508a9fed46">CY_BLE_GAP_SEC_LEVEL_1</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_ble_config.authInfo[CY_BLE_SECURITY_CONFIGURATION_0_INDEX].authErr<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__gap__definitions_1gga8111b4f1559c12cc45f0f9babb16f823a8fa09a4257c09e58cfefb9fa1e04569b">CY_BLE_GAP_AUTH_ERROR_PAIRING_NOT_SUPPORTED</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}<sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_ble_config.authInfo[CY_BLE_SECURITY_CONFIGURATION_0_INDEX].bdHandle<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((<ref kindref="compound" refid="structcy__stc__ble__gap__auth__info__t">cy_stc_ble_gap_auth_info_t</ref><sp />*)eventParam)-&gt;bdHandle;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__ble__common__api__gap__peripheral__functions_1gafd058b11ddcf322f0389c51917465334">Cy_BLE_GAPP_AuthReqReply</ref>(&amp;cy_ble_config.authInfo[CY_BLE_SECURITY_CONFIGURATION_0_INDEX])<sp />!=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__definitions_1gga63f6be7f53f5ad7d82c394e4cdfa619ea26e476ee364252903ce212deeb6ec064">CY_BLE_SUCCESS</ref>)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__gap__functions_1ga8dd8f2851594f8512b09819e13bd1d7c">Cy_BLE_GAP_RemoveOldestDeviceFromBondedList</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__common__api__gap__peripheral__functions_1gafd058b11ddcf322f0389c51917465334">Cy_BLE_GAPP_AuthReqReply</ref>(&amp;cy_ble_config.authInfo[CY_BLE_SECURITY_CONFIGURATION_0_INDEX]);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
</programlisting></para>

<para><heading level="1">Service-specific Event Handler</heading></para>
<para>The PSoC 6 BLE Middleware also generates events corresponding to each of the services supported by the design. For the Find Me Target application, the PSoC 6 BLE Middleware generates IAS events that let the application know that the Alert Level characteristic has been updated with a new value. The event handler gets the new value and stores it in the variable alertLevel. The main loop toggles the alert LED based on the current alert level.</para><para>The code snippet shows how the firmware accomplishes this task. <programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />IasEventHandler(uint32_t<sp />event,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*eventParam)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Alert<sp />Level<sp />Characteristic<sp />write<sp />event<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(event<sp />==<sp /><ref kindref="member" refid="group__group__ble__service__api__events_1ggada4b6b6d080ad4380e3a2e3cab4f2d51a892e3adb2589cde7257346928e97ee59">CY_BLE_EVT_IASS_WRITE_CHAR_CMD</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />the<sp />updated<sp />Alert<sp />Level<sp />value<sp />from<sp />the<sp />GATT<sp />database<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ble__service__api___i_a_s__server_1ga1898e12f1c143f416553829d42b04089">Cy_BLE_IASS_GetCharacteristicValue</ref>(<ref kindref="member" refid="group__group__ble__service__api___i_a_s__definitions_1ggad27f470965bbd7e1938ef52ec411d11fa0e8d27cc4a06ffa0a7f27cea77a0aa1f">CY_BLE_IAS_ALERT_LEVEL</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(alertLevel),<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;alertLevel);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp />eventParam;</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><heading level="1">Implement Low-power Performance</heading></para>
<para>In the application process, the CPU processes the pending BLE events. If there are no events pending, the CPU enters the deep sleep power mode. <programlisting><codeline><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Function<sp />Name:<sp />LowPowerImplementation</highlight></codeline>
<codeline><highlight class="comment">********************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Summary:<sp />Implements<sp />low<sp />power<sp />in<sp />the<sp />project.</highlight></codeline>
<codeline><highlight class="comment">*</highlight></codeline>
<codeline><highlight class="comment">*<sp />Theory:</highlight></codeline>
<codeline><highlight class="comment">*<sp /><sp />The<sp />function<sp />tries<sp />to<sp />enter<sp />CPU<sp />deep<sp />sleep<sp />as<sp />much<sp />as<sp />possible<sp />-<sp />whenever<sp />the</highlight></codeline>
<codeline><highlight class="comment">*<sp /><sp />BLE<sp />is<sp />idle.</highlight></codeline>
<codeline><highlight class="comment">*</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />LowPowerImplementation(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Entering<sp />Deep<sp />Sleep<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysPm_DeepSleep(CY_SYSPM_WAIT_FOR_INTERRUPT);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>
    </detaileddescription>
  </compounddef>
</doxygen>